package hw4;

import futils.Futil;
import gui.In;
import gui.run.RunMenu;
import gui.run.RunMenuBar;
import gui.run.RunMenuItem;
import gui.run.RunJob;
import net.stocks.Quote;
import net.web.UrlUtils;
import javax.swing.*;
import java.awt.*;
import java.util.Vector;

import utils.PreferencesUtils;


public class Hw4Quotes extends gui.ClosableJFrame {
    Vector quotes = new Vector();
    JLabel labels[] = new JLabel[1000];
    Vector vec = new Vector();
     AddQuotes aq = new AddQuotes(this);
    public PreferencesUtils pref= new PreferencesUtils("quotes");


    public void init() {
        Container c = getContentPane();
        c.add(setJMenuBar());
        getQuotes();
        setBackground(Color.white);
        if ((Vector)pref.restore() != null)  {

       vec = (Vector)pref.restore();

        getQuotes();
        for (int i = 0; i < quotes.size(); i++) {
            String s =
                    (String) quotes.elementAt(i);
            quoteLineToStringVector(s);
            labels[i] = new JLabel(s);
            addComponent(labels[i]);
        }
        setContainerLayout(new GridLayout(0, 1));
         pack();
        setVisible(true);
    }
    }

    private RunMenuBar setJMenuBar() {
        RunMenuBar mb = new RunMenuBar();
        mb.add(getFileMenu());
        return mb;
    }

    public RunMenu getFileMenu() {
        RunMenu fileMenu = new RunMenu("[File");

        fileMenu.add(new RunMenuItem("[Add{alt shift A}") {
            public void run() {

                aq.init();


            }
        });
            fileMenu.add(new RunMenuItem("[save{alt shift S}") {
            public void run() {
                 pref.save(vec);             }
        });
              fileMenu.add(new RunMenuItem("[quit{alt shift Q}") {
            public void run() {
                System.exit(0);
            }
        });
        return fileMenu;
    }

    public String getQuote() {
        String s = JOptionPane.showInputDialog("Please enter a stock symbol");
        boolean b = isValidSymbol(s);
        if(b == false)
           JOptionPane.showMessageDialog(null,"Was not a valid symbol");
        else {
            vec.addElement(s);
            return s;
        }
        return null;
    }

    public void addSymbol(String s){
        vec.addElement(s);
    }


    public String[] quoteLineToStringVector(String pcs) {
        Vector stringVector =
                new Vector();
        String s = new String(pcs);
        //separate the strings delimited by commas
        for (
                int i = s.indexOf(',');
                i >= 0;
                i = s.indexOf(',')) {
            stringVector.addElement(s.substring(0, i));
            s = new String(s.substring(i + 1));
        }
        // add the last String left
        stringVector.addElement(s);
        String sa[] =
                new String[stringVector.size()];
        for (int i = 0; i < sa.length; i++)
            sa[i] = (String) stringVector.elementAt(i);
        return sa;
    }

    public void println(String s[]) {
        for (int i = 0; i < s.length; i++)
            System.out.println(s[i]);
    }

    public void print(String s[]) {
        for (int i = 0; i < s.length; i++)
            System.out.print(s[i] + ' ');
        System.out.println();
    }

    public void updateDisplay() {
        vec = (Vector)pref.restore();
        getQuotes();
         int q = 0;
         for(int x = 0; x <labels.length -1; x++)  {
             if(labels[x]!= null)
                q = x;

         }

       if(labels[quotes.size()] != null && labels.length -1 > quotes.size()){
           for (int n =quotes.size(); n<=q;n++){
               labels[n].setText("");
           }

       }

        for (int i = 0; i < quotes.size(); i++) {
            if (labels[i] != null){
            labels[i].setText(
                   (String) quotes.elementAt(i));
        }else{
            labels[i] = new JLabel((String)quotes.elementAt(i));
            addComponent(labels[i]);
        }

        }
    }

    public void paint(Graphics g) {
        new RunJob(5,false){
            public void run(){
                updateDisplay();
            }
        };
         pack();
        super.paint(g);
    }

    public static boolean isValidSymbol(String symbol){
        Vector v = new Vector();
        String s = "http://finance.yahoo.com/q/op?s="+symbol;
        v = UrlUtils.getUrlVector(s);
        s = v.elementAt(0).toString();
        String s2 = s.substring(91,98);
        if(s2.equals("Invalid"))
        return false;

        return true;
    }
    public Vector getQuotes() {

        return quotes = Quote.getUrl(Quote.makeQuoteURLString(vec));
    }

    public static void main(String args[]) {
        Hw4Quotes qf = new Hw4Quotes();
        qf.init();
    }

}